package vt.CS5934.SwitchRoom.repositories;

import org.springframework.data.jpa.repository.JpaRepository;
import vt.CS5934.SwitchRoom.models.MatchedRecordIdModel;
import vt.CS5934.SwitchRoom.models.MatchedWishlistRecordModel;

import java.util.List;

public interface MatchedWishlistRecordRepository extends JpaRepository<MatchedWishlistRecordModel, MatchedRecordIdModel> {
    void deleteAllByOfferId(Long offerId);
    void deleteAllByWishlistItemId(Long wishlistItemId);

    /**
     * The function name is the SQL query:
     *  findByIdAndName(long inputId, String inputName) == "SELETE * FROM table WHERE Id==inputId" AND name == inputName;
     * This is an example of how to declare a SQL command, those will be use in service class
     * @param userId the id in table you are looking for
     * @return ExampleModel object
     */
    List<MatchedWishlistRecordModel> findByOfferId(long userId);
}
